//test prog for the GSMP_Stuff;-)

#include <stdio.h>
#include <iostream.h>
#include <stdlib.h> //rand ...
#include <ctype.h>  //toupper
#include <string.h> //memset

#include "include.hh"
#include "typedefs.hh"
#include "Data.hh"

using namespace GSML;

DataFileIndex* my_index;
TrackLayer* my_track;

void test_it ()
{
  SampleBuffer16Bit* my_buffer;

  cout << "test_it: " << endl;
  
  my_buffer =  new SampleBuffer16Bit (15000);
  my_buffer->SetUsedLength (15000);
  cout << "PrepareInsertWrite (0):" << endl;
  my_track->PrepareInsertWrite (0);
  cout << "WriteData (15000):" << endl;
  my_track->WriteData (5000, my_buffer, 0);
  cout << "FixateWrite ():" << endl;
  my_track->FixateWrite ();
  
  cout << "PrepareInsertWrite (0):" << endl;
  my_track->PrepareInsertWrite (0);
  cout << "WriteData (7000):" << endl;
  my_track->WriteData (7000, my_buffer, 0);
  cout << "FixateWrite ():" << endl;
  my_track->FixateWrite ();
  
  cout << "PrepareInsertWrite (0):" << endl;
  my_track->PrepareInsertWrite (0);
  cout << "WriteData (11000):" << endl;
  my_track->WriteData (11000, my_buffer, 0);
  cout << "FixateWrite ():" << endl;
  my_track->FixateWrite ();
  
  delete my_buffer;
}


main ()
{
  cout << "test 4 GSML::TrackLayer:" << endl;

  try
    {
      DataFileIndex::Config my_index_config;
      
      my_index_config.filename_base = "test-file_";
      my_index_config.filename_ext = ".tmp";
      my_index_config.working_dir = "./test/";
      cout << "creating new GSML_Data_File_Index: " << endl;
      my_index = new DataFileIndex (my_index_config);

      cout << "test GSMLDataFileIndex config:" << endl;
      bool configured = my_index->Configure (true);
      
      if (!configured)
	cout << "Error: DataFileIndex::Config invaild..." << endl;
      else
	{
	  pcm_16bit pcm_type;
	  
	  cout << "creating new GSML::TrackLayer: " << endl;
	  my_track = new TrackLayer (my_index, &pcm_type, 44100);

	  test_it ();

	  my_track->Debug ();
	  my_index->Debug ();

	  TrackLayer* test_track;

	  cout << "---------------------- 1st TEST -------------------:" << endl;
	  cout << "copy ctor test:" << endl;
	  test_track = new TrackLayer (*my_track);
	  cout << "----------------------------------------------------" << endl;

	  test_track->Debug ();
	  my_index->Debug ();
	  
	  cout << "---------------------- 2nd TEST -------------------:" << endl;
	  cout << "operator= test:" << endl;
	  *test_track = *my_track;
	  cout << "----------------------------------------------------" << endl;

	  test_track->Debug ();
	  my_index->Debug ();
	  
	  cout << "---------------------- 3rd TEST -------------------:" << endl;
	  cout << "CreateTrackLayer test (5000, 10000):" << endl;
	  cout << "destroying test_track for futher use ..." << endl;
	  delete test_track;
	  test_track = my_track->CreateTrackLayer (5000, 10000);
	  cout << "----------------------------------------------------" << endl;
      
	  test_track->Debug ();
	  my_index->Debug ();
	  
	  // ------- mem corruption ...
	  
	  cout << "---------------------- 4th TEST -------------------:" << endl;
	  cout << "InsertTrackLayer test (100, my_track):" << endl;
	  
	  cout << "inserting:" << endl;
	  my_track->Debug ();
	  cout << "into:" << endl;
	  test_track->Debug ();
	  
	  test_track->InsertTrackLayer (100, *my_track);
	  
	  cout << "track_layer debug:" << endl;
	  test_track->Debug ();
	  
	  // ----------
	  
	  cout << "----------------------------------------------------" << endl;
	  cout << "---------------------- 5th TEST -------------------:" << endl;
	  // cout << "" << endl;
	  TrackLayer::Entry my_entry;
	  int n_test;
      
	  cout << endl << "--> now the test ..." << endl;
      
	  cout << "track contains this entries: " << endl;
	  TrackLayer::const_iterator i;
	  for (i = test_track->Begin (); i != test_track->End (); ++i)
	    {
	      cout << "getting and debugging entry: " << i - test_track->Begin () << ":" << endl;
	      (*i)->Debug ();
	    }
	  cout << "try to reinsert the last entry we got:" << endl;
	  cout << "@ index 0:" << endl;
	  test_track->InsertRawEntry (test_track->Begin (), **i);
	  cout << "@ index End ():" << endl;
	  test_track->InsertRawEntry (test_track->End (), **i);
      
	  cout << "----------------------------------------------------" << endl;
	  
	  test_track->Debug ();
	  my_track->Debug ();
	  my_index->Debug ();
	  
	  cout << "deleting Track_Layer: " << endl;
	  delete test_track;
	  my_index->Debug ();
	  delete my_track;
	  cout << "END of test scope ..." << endl;
	} // end if (configured)
      my_index->Debug ();
      
      cout << "deleting Data_File_Index:" << endl;
      my_index->DeleteUnusedIndexes ();
      delete my_index;
      
    }
  catch (TrackLayer::Except e)
    {
      cout << "EE XX EE PP TT II OO NN !! !! ::" << endl;
      cout << e.info << endl;
    }

  return 0;
}
