/*  GSMP - General Sound Manipulation Program
 *  Copyright (C) 2000-2001 Valentin Ziegler and Ren Rebe
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/* Short Description:
 *   GSMP shared basics
 */

#ifndef GSMP_BASE_HH
#define GSMP_BASE_HH

#include <string>

#include <sigc++/signal_system.h>
#include "Factory.hh"
#include "generated/Debug.hh"

using namespace std;

namespace GSMP
{
    /* GSMP Base exception */

    class Exception : public GSMX_utils :: BaseException 
    {
    public:
      Exception (const string& errmsg) : BaseException (string ("GSMP : ") + errmsg) {};
    };

} // end namespace GSMP

#endif // GSMP_BASE_HH
