/*  GSMP - General Sound Manipulation Program
 *  Copyright (C) 2000-2001 Valentin Ziegler and Ren Rebe
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/* Short Description:
 *   
 */

#ifndef GSMP_GTK_DIALOG_HH
#define GSMP_GTK_DIALOG_HH

#include "ToolkitBasics.hh"
#include "Activator.hh"

class Dialog :  public GSMP::Menu::StatusActivator, public SigC::Object
{
public:
  virtual bool Execute (bool state);
protected:
  Dialog (GSMP::App* i_app, GSMP::Project* i_project, GSMP::View* i_view, string i_location);
  virtual ~Dialog ();
  virtual Gtk::Widget* Create () = 0; 
private:
  void SlotDialogDeleted ();
  Gtk::Widget* m_dialog;
  SigC::Connection slot_dialog_deleted;
  string m_location;
};

#endif // GSMP_GTK_DIALOG_HH
