/*  GSMP - General Sound Manipulation Program
 *  Copyright (C) 2000-2001 Valentin Ziegler and Ren Rebe
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/* Short Description:
 *   
 */

#include "PluginInterface.hh"

#include "FileDialog.hh"
#include "LayerHistoryDialog.hh"
#include "TrackManagerDialog.hh"
#include "ViewDialog.hh"
#include "IODialog.hh"
#include "MixerDialogs.hh"
#include "ParamDialogs.hh"
#include "AboutDialog.hh"

/********************************** Interface Part **********************************/

START_PLUGIN_INTERFACE;
PLUGIN_ITEM("Function","ImportDialogX", "Ren Rebe <rene.rebe@gmx.net>","2001-07-21","Project>Import&N&100:Project:Item:State=on", NULL);
PLUGIN_ITEM("Function","ExportDialogX", "Ren Rebe <rene.rebe@gmx.net>","2001-07-22","Project>Export&N&110:Project:Item:State=on", NULL);
PLUGIN_ITEM("Function","MixExportDialogX", "Ren Rebe <rene.rebe@gmx.net>","2001-08-22","Project>Mix Export&N&120:Project:Item:State=on", NULL);
PLUGIN_ITEM("Function","LayerHistoryDialogX", "Ren Rebe <rene.rebe@gmx.net>","2001-07-22","Dialogs>Layer History:Project:Checked:State=on", NULL);
PLUGIN_ITEM("Function","TrackManagerDialogX", "Ren Rebe <rene.rebe@gmx.net>","2001-09-18","Dialogs>Track Manager:Project:Checked:State=on", NULL);
PLUGIN_ITEM("Function","ViewDialogX", "Valentin <ziegler@informatik.hu-berlin.de>","2001-07-26","Dialogs>View List:App:Checked:State=on", NULL);
PLUGIN_ITEM("Function","IODialogX", "Valentin <ziegler@informatik.hu-berlin.de>","2001-08-04","Dialogs>IO Control&B:Project:Checked:State=on", NULL);
PLUGIN_ITEM("Function","PLChannelDialogX", "Ren Rebe <rene.rebe@gmx.net>","2001-08-04","Dialogs>Playback channel mix&F&0:Project:Checked:State=on", NULL);
PLUGIN_ITEM("Function","CAChannelDialogX", "Ren Rebe <rene.rebe@gmx.net>","2001-08-04","Dialogs>Capture channel mix&F&1:Project:Checked:State=on", NULL);
PLUGIN_ITEM("Function","PLTrackDialogX", "Ren Rebe <rene.rebe@gmx.net>","2001-08-04","Dialogs>Playback track mix&D&0:Project:Checked:State=on", NULL);
PLUGIN_ITEM("Function","CATrackDialogX", "Ren Rebe <rene.rebe@gmx.net>","2001-08-04","Dialogs>Capture track mix&D&1:Project:Checked:State=on", NULL);
PLUGIN_ITEM("Function","AboutDialogX", "Ren Rebe <rene.rebe@gmx.net>","2001-09-19","Help>About:App:Item:State=on", NULL);
END_PLUGIN_INTERFACE;

PLUGIN_FACTORY(Function,ImportDialogX,GSMP::Menu::Activator,ImportDialogX,(GSMP::App* i_app, GSMP::Project* i_project, GSMP::View* i_view),(i_app, i_project, i_view))
PLUGIN_FACTORY(Function,ExportDialogX,GSMP::Menu::Activator,ExportDialogX,(GSMP::App* i_app, GSMP::Project* i_project, GSMP::View* i_view),(i_app, i_project, i_view))
PLUGIN_FACTORY(Function,MixExportDialogX,GSMP::Menu::Activator,MixExportDialogX,(GSMP::App* i_app, GSMP::Project* i_project, GSMP::View* i_view),(i_app, i_project, i_view))
PLUGIN_FACTORY(Function,LayerHistoryDialogX,GSMP::Menu::StatusActivator,LayerHistoryDialogX,(GSMP::App* i_app, GSMP::Project* i_project, GSMP::View* i_view),(i_app, i_project, i_view))
PLUGIN_FACTORY(Function,TrackManagerDialogX,GSMP::Menu::StatusActivator,TrackManagerDialogX,(GSMP::App* i_app, GSMP::Project* i_project, GSMP::View* i_view),(i_app, i_project, i_view))
PLUGIN_FACTORY(Function,ViewDialogX,GSMP::Menu::StatusActivator,ViewDialogX,(GSMP::App* i_app, GSMP::Project* i_project, GSMP::View* i_view),(i_app, i_project, i_view))
PLUGIN_FACTORY(Function,IODialogX,GSMP::Menu::StatusActivator,IODialogX,(GSMP::App* i_app, GSMP::Project* i_project, GSMP::View* i_view),(i_app, i_project, i_view))
PLUGIN_FACTORY(Function,PLChannelDialogX,GSMP::Menu::StatusActivator,PLChannelDialogX,(GSMP::App* i_app, GSMP::Project* i_project, GSMP::View* i_view),(i_app, i_project, i_view))
PLUGIN_FACTORY(Function,CAChannelDialogX,GSMP::Menu::StatusActivator,CAChannelDialogX,(GSMP::App* i_app, GSMP::Project* i_project, GSMP::View* i_view),(i_app, i_project, i_view))
PLUGIN_FACTORY(Function,PLTrackDialogX,GSMP::Menu::StatusActivator,PLTrackDialogX,(GSMP::App* i_app, GSMP::Project* i_project, GSMP::View* i_view),(i_app, i_project, i_view))
PLUGIN_FACTORY(Function,CATrackDialogX,GSMP::Menu::StatusActivator,CATrackDialogX,(GSMP::App* i_app, GSMP::Project* i_project, GSMP::View* i_view),(i_app, i_project, i_view))
PLUGIN_FACTORY(Function,AboutDialogX,GSMP::Menu::Activator,AboutDialogX,(GSMP::App* i_app, GSMP::Project* i_project, GSMP::View* i_view),(i_app, i_project, i_view))
