/*  GSMP - General Sound Manipulation Program
 *  Copyright (C) 2000-2001 Ren Rebe and Valentin Ziegler
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/* Short Description:
 *   The File dialog.
 */

#include "ToolkitBasics.hh"
#include "Activator.hh"

#include <gtk--/fileselection.h> 

class FileDialog : public Gtk::FileSelection
{
public:
  FileDialog (GSMP::Project* i_project, int i_mode);
  ~FileDialog ();
  
private:
  void slot_ok ();
  
  GSMP::Project* m_project;
  int m_mode; // true import; false export
};

class ImportDialogX : public GSMP::Menu::Activator
{
public:
  ImportDialogX (GSMP::App* i_app, GSMP::Project* i_project, GSMP::View* i_view)
    : Activator (i_app, i_project, i_view)
  {}
  
  virtual void Execute ();
};

class ExportDialogX : public GSMP::Menu::Activator
{
public:
  ExportDialogX (GSMP::App* i_app, GSMP::Project* i_project, GSMP::View* i_view)
    : Activator (i_app, i_project, i_view)
  {}
  
  virtual void Execute ();
};

class MixExportDialogX : public GSMP::Menu::Activator
{
public:
  MixExportDialogX (GSMP::App* i_app, GSMP::Project* i_project, GSMP::View* i_view)
    : Activator (i_app, i_project, i_view)
  {}
  
  virtual void Execute ();
};
