/*  GSMP - General Sound Manipulation Program
 *  Copyright (C) 2000-2001 Valentin Ziegler and Ren Rebe
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/* Short Description:
 *   
 */

#include "PluginInterface.hh"
#include "DefaultWindows.hh"
#include "NormalView.hh"
#include "ParamDialogs.hh"

/********************************** Interface Part **********************************/

START_PLUGIN_INTERFACE;
PLUGIN_ITEM("GUI","ParameterDialog_gtk","Valentin <ziegler@informatik.hu-berlin.de>","2001-08-09","", NULL);
PLUGIN_ITEM("GUI","EnhParameterDialog_gtk","Valentin <ziegler@informatik.hu-berlin.de>","2001-08-17","", NULL);
PLUGIN_ITEM("GUI","MainWindow", "Valentin <ziegler@informatik.hu-berlin.de>","2001-06-21","", NULL);
//TODO: PLUGIN_ITEM("GUI","SimpleWindow", "Valentin <ziegler@informatik.hu-berlin.de>","2001-","", NULL);
PLUGIN_ITEM("ViewImpl","normal", "Ren Rebe <rene.rebe@gmx.net>","2001-07-21","", NULL);
END_PLUGIN_INTERFACE;

PLUGIN_FACTORY(GUI,ParameterDialog_gtk,GSMP::ParameterDialog,ParameterDialogGtk,(GSMP::ParameterDialogAction* action, GSMP::Project* project, string title),(action, project, title));
PLUGIN_FACTORY(GUI,EnhParameterDialog_gtk,GSMP::EnhParameterDialog,EnhParameterDialogGtk,(GSMP::DialogAction* action, string title),(action, title));
PLUGIN_FACTORY(GUI,MainWindow,GSMP::MainWindow,DefaultMainWindowGtk,(GSMP::App* i_app, GSMP::View* i_view),(i_app, i_view));
PLUGIN_FACTORY(ViewImpl,normal,GSMP::ViewImpl,GSMP::NormalView,(GSMP::View* i_view),(i_view));
