/*  GSMP - General Sound Manipulation Program
 *  Copyright (C) 2000-2001 Ren Rebe and Valentin Ziegler
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/* Short Description:
 *   The IO control dialog.
 */

#include "Dialog.hh"

#include <gtk--/dialog.h> 
#include <gtk--/label.h> 
#include <gtk--/progressbar.h>
#include <gtk--/frame.h>

class IODialog : public Gtk::Dialog
{
public:
  IODialog (GSMP::Project* i_project);
  ~IODialog () {};
  
private:
  void SlotTimeRefresh  ();
  void SlotViewErased ();

  GSMP::Project* m_project;

  ButtonGtk start_io;
  ButtonGtk stop_io;
  CheckButtonGtk do_playback;
  CheckButtonGtk do_capture;
  CheckButtonGtk sel_play;
  CheckButtonGtk sel_capture;
  CheckButtonGtk hear_fx;
  CheckButtonGtk do_loop;
  CheckButtonGtk do_stop_at_end;

  Gtk::Label time;
  
  Gtk::Frame io_status;
  
  Gtk::Label pl_label;
  Gtk::Label ca_label;
  Gtk::ProgressBar queue;
  
  Gtk::HBox start_stop_box;
  Gtk::Button close_button;

  SigC::Connection connection_view_erased;

  int old_blocks;
};


class IODialogX : public Dialog
{
public:
  IODialogX (GSMP::App* i_app, GSMP::Project* i_project, GSMP::View* i_view)
    : Dialog (i_app, i_project, i_view, string ("Dialogs>IO Control")) {};
  
  virtual Gtk::Widget* Create ();
};
