/*  GSMP - General Sound Manipulation Program
 *  Copyright (C) 2000-2001 Ren Rebe and Valentin Ziegler
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/* Short Description:
 *   Layer history dialog.
 */

#include "Dialog.hh"

#include <gtk--/dialog.h> 
#include <gtk--/clist.h>
#include <gtk--/scrolledwindow.h>
#include <gtk--/label.h> 

class LayerHistoryDialog : public Gtk::Dialog
{
public:
  LayerHistoryDialog (GSMP::Project* i_project);
  virtual ~LayerHistoryDialog ();
  
private:
  
  void SlotCurrentLayerChanged (GSML::DataLayer* n_layer);
  void SlotNewLayerPrepared (GSML::DataLayer* n_layer);
  void SlotNewLayerFixated ();
  void SlotNewLayerCanceled ();
  
  void slot_selected (gint row, gint column, GdkEvent* event);
  
  void build_list ();
  
  // hack:
  bool internal_select;
  
  Gtk::CList* m_clist;
  Gtk::ScrolledWindow* m_scrolled_window;
  Gtk::Label* l_prepared_layer;
  
  GSMP::Project* m_project;
};


class LayerHistoryDialogX : public Dialog
{
public:
  LayerHistoryDialogX (GSMP::App* i_app, GSMP::Project* i_project, GSMP::View* i_view)
    : Dialog (i_app, i_project, i_view, string ("Dialogs>Layer History") ) {};
  
  virtual Gtk::Widget* Create ();
};
