/*  GSMP - General Sound Manipulation Program
 *  Copyright (C) 2000-2001 Ren Rebe and Valentin Ziegler
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/* Short Description:
 *   The startup splash-screen.
 */

#include "GUI.hh"

#include <gtk--/box.h>
#include <gtk--/label.h>
#include <gtk--/progressbar.h>
#include <gtk--/pixmap.h>
#include <gtk--/window.h>
#include <gtk--/main.h>

class SplashScreen  : public GSMP::GUI::InitScreen, public Gtk::Window
{ 
public:
  SplashScreen (Gtk::Main& m_kit);
  virtual void Update (string status_msg, double progress);
private:
  Gtk::VBox* m_vbox;
  Gtk::Pixmap* m_pixmap;
  Gtk::Label* m_head_label;
  Gtk::Label* m_detail_label;
  Gtk::ProgressBar* m_progressbar;
  Gtk::Main& m_kit;
};

