/*  GSMP - General Sound Manipulation Program
 *  Copyright (C) 2000-2001 Ren Rebe and Valentin Ziegler
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/* Short Description:
 *   The status-bar.
 */

#include "ToolkitBasics.hh"
#include <gtk--/box.h>
#include <gtk--/frame.h>
#include <gtk--/progressbar.h>
#include <gtk--/label.h>

class StatusBar : public Gtk::HBox
{
public:
  StatusBar (GSMP::View* i_view);
private:
  Gtk::Frame* FrameWidget (Gtk::Widget& widget);

  void SlotPointerMoved (GSML::sample_index pos);
  void SlotLayerChanged (GSML::DataLayer* ignored);
  void SlotMessageInfoUpdated ();
  void SlotInfoPushed (const GSML::Data::ProgressInfo::Info* info);
  void SlotInfoUpdated (const GSML::Data::ProgressInfo::Info* info);
  void SlotInfoPopped ();
  void InsertProgress (const GSML::Data::ProgressInfo::Info* info);
  void RemoveProgress ();


  Gtk::ProgressBar m_progress;
  ButtonGtk cancel;
  Gtk::Label m_project_message;
  Gtk::Label m_mouse_position;
  Gtk::Label m_project_length;
  ToggleButtonGtk follow_curpos;
  ToggleButtonGtk follow_io;

  GSMP::View* m_view;
  GSMP::Project* m_project;

  SigC::Connection slot_pointer_moved;

  bool progress_shown;
};
