/*  GSMP - General Sound Manipulation Program
 *  Copyright (C) 2000-2001 Valentin Ziegler and Ren Rebe
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/* Short Description:
 *   The track-info widget.
 */

#ifndef GSMP_TRACK_INFO_GTK_HH
#define GSMP_TRACK_INFO_GTK_HH

#include "ToolkitBasics.hh"

#include <gtk--/table.h>
#include <gtk--/entry.h>

class TrackInfo : public Gtk::Table
{
public:
  TrackInfo (GSMP::Project* i_project, GSML::track_index i_track_no);

  void SetDataLayer (GSML::DataLayer* new_layer);
private:
  //void SlotDataLayerChanged (GSML::DataLayer* new_layer);
  void SlotNameChanged (const string& new_name); // Track Name Changed
  void SlotNameChangedUser (); // Name changed by user

  void SlotMuteChanged (GSML::track_index track, bool new_state);
  void SlotMuteChangedUser ();

  void SlotRecChanged (GSML::track_index track, bool new_state);
  void SlotRecChangedUser ();

  void SlotActiveChanged (bool new_state);  // Selection IsActive changed
  void SlotActiveChangedUser (); // User changed active

  void SlotHide ();

  Gtk::Entry name;
  Gtk::ToggleButton mute;
  Gtk::ToggleButton rec;
  Gtk::ToggleButton active;
  Gtk::Button hide_track;

  SigC::Connection slot_name_changed;
  SigC::Connection slot_active_changed;

  GSMP::Project* m_project;
  GSML::track_index m_track_no;

  GSML::DataLayer* m_dlayer;
  GSML::TrackLayer* m_tlayer;

  bool name_external_changed;
  bool mute_external_changed;
  bool rec_external_changed;
  bool active_external_changed;
};

class TrackInfoHACK : public Gtk::Window
{
public:
  TrackInfoHACK (GSMP::Project* i_project)
     : m_info (i_project, 0)
  {
    using namespace Gtk;
    add (m_info);
    show_all ();
  }

private:
  TrackInfo m_info;
};

#endif // GSMP_TRACK_INFO_GTK_HH
