/*  GSMP - General Sound Manipulation Program
 *  Copyright (C) 2000-2001 Ren Rebe and Valentin Ziegler
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/* Short Description:
 *   The track manager dialog.
 */

#include "Dialog.hh"

#include <gtk--/dialog.h> 
#include <gtk--/clist.h>
#include <gtk--/scrolledwindow.h>
#include <gtk--/label.h> 

// the more I use Gtk(--) and the stuff from the drunken(??) Posix people
// the more I want a GPL OO OS and GUI !!!!!!!!!!!!

class UseableCList : public Gtk::CList
{
public:
  UseableCList (int columns, const gchar* titles[] = 0)
    : Gtk::CList (columns, titles) {};
  UseableCList (const Gtk::SArray& titles)
    : Gtk::CList (titles) {};
  
  SigC::Signal2 <void, gint, gint> row_moved;
  
  virtual void row_move_impl (gint p0, gint p1)
  {
    Gtk::CList::row_move_impl (p0, p1);
    row_moved (p0, p1);
  };
};

class TrackManagerDialog : public Gtk::Dialog
{
public:
  TrackManagerDialog (GSMP::Project* i_project);
  virtual ~TrackManagerDialog ();
  
private:
  
  void build_list (GSML::DataLayer* layer);
  
  void SlotCurrentLayerChanged (GSML::DataLayer* n_layer);
  
  void SlotInsertButton ();
  void SlotDeleteButton ();
  
  // needed to track what gtk-- does with the rows during row dnd
  void SlotRowMoved (gint p0, gint p1);
  
  // do the FX pre / post stuff ...
  bool InternalEditStart (const string& undo_info);
  void InternalEditEnd ();
  
  GSML::DataLayer* m_prepared_layer;
  
  UseableCList* m_clist;
  Gtk::ScrolledWindow* m_scrolled_window;
  
  Gtk::HBox m_button_box;
  Gtk::Button* m_insert_button;
  Gtk::Button* m_delete_button;
  
  GSMP::Project* m_project;
  
  int hack;
};


class TrackManagerDialogX : public Dialog
{
public:
  TrackManagerDialogX (GSMP::App* i_app, GSMP::Project* i_project, GSMP::View* i_view)
    : Dialog (i_app, i_project, i_view, string ("Dialogs>Track Manager") ) {};
  
  virtual Gtk::Widget* Create ();
};
