/*  GSMP - General Sound Manipulation Program
 *  Copyright (C) 2000-2001 Valentin Ziegler and Ren Rebe
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/* Short Description:
 *   
 */

PLUGIN_ITEM("Function","XYPlugin", "Valentin Ziegler <valentin.ziegler@student.hu-berlin.de>","2001-08-09","Filters>x>y:Item:State=on", NULL);

class XYPlugin : public GSMP::Menu::Activator
{
public:
  XYPlugin (GSMP::App* i_app, GSMP::Project* i_project, GSMP::View* i_view)
    : Activator (i_app, i_project, i_view) {}
  
  virtual void Execute ()
  {
    Action* t_action = new Action (m_project);
    SigC::Handle <GSMP::EnhParameterDialog, SigC::Scopes::Extend> t_dialog;
    t_dialog = m_project -> FXConfigDialog (t_action, string ("XY"));
    t_dialog -> Show ();
  }

private:

  class Action : public GSMP::LinearMonoFXPlugFactory <xy>, public GSMP::DialogAction
  {
  public:
    virtual xy* Create ()
    {
      return new xy (...);
    }

    virtual void Launch ()
    {
      //...
    }

    virtual bool IsEnabled ()
    {
      return true;
    }

    virtual void Init (GSMP::EnhParameterDialog* dialog)
    {
      //dialog -> AddValue (xxx, string ("..."));
      dialog -> AddValue (prehear, string (""));
    }

    virtual void Reset (GSMP::EnhParameterDialog* dialog)
    {
      dialog -> Reset ("");

      // xxx -> Set (xxx -> Default ());
      
      Init (dialog);
      dialog -> Show ();
    }

    Action (GSMP::Project* i_project)
    {
      m_project = i_project;

      // initialaize values
      //level = new GSMP::SingleVolume (0, 1, 1, v, string ("Level"));
      //frequency = new GSMP::SingleFrequency (2.0 * M_PI * 30.0 / 44100.0,
      //			             2.0 * M_PI * 15000.0 / 44100.0,
      //				     2.0 * M_PI * 300.0 / 44100.0,
      //				     f, 44100, string ("Frequency"));

      //init Prehear button
      prehear = new GSMP::PrehearButton <xy> (m_project, *this);
      //prehear -> SetInteractiveDouble (&SimpleSinusGen::SetVol, &v, *level);

    }

    ~Action ()
    {
      delete prehear;
      //delete parameters

    }

    // Dialog Elements
    //GSMP::SingleVolume* level;
    //GSMP::SingleFrequency* frequency;
    GSMP::PrehearButton <SimpleSinusGen>* prehear;

    GSMP::Project* m_project;

    // FX Values
  };
};

PLUGIN_FACTORY(Function,XYPlugin,GSMP::Menu::Activator,XYPlugin,(GSMP::App* i_app, GSMP::Project* i_project, GSMP::View* i_view),(i_app, i_project, i_view));
