/*  GSMP - General Sound Manipulation Program
 *  Copyright (C) 2000-2001 Valentin Ziegler and Ren Rebe
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/* Short Description:
 *   
 */

#include "ParameterDialog.hh"

using namespace GSMP;

ParameterDialog::ParameterDialog (ParameterDialogAction* i_action, Project* i_project)
{
  m_action = i_action;
  m_project = i_project;
}

ParameterDialog::~ParameterDialog ()
{
  delete m_action;
}

void ParameterDialog::Launch ()
{
  FXBase* t_fx = m_action -> Build ();
  if (t_fx)
    m_project -> DoFX (t_fx);
}



EnhParameterDialog::EnhParameterDialog (DialogAction* i_action)
{
  m_action = i_action;
}

EnhParameterDialog::~EnhParameterDialog ()
{
  delete m_action;
}
