/*  GSMP - General Sound Manipulation Program
 *  Copyright (C) 2000-2001 Valentin Ziegler and Ren Rebe
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/* Short Description:
 *   The executable main program.
 */

#include <App.hh>

using namespace GSMP;
using namespace GSML;

int main (int argc, char *argv[] )
{
  cout << "Welcome to GSMP" << endl;

  App* m_app;
  Manager m_manager;

  try
    {
      m_app = new App (argc, argv, string ("gsmp-main.so"), string ("Toolkit-gtk.so"), &m_manager);
      m_app -> Run ();
      cout << "Run returned" << endl;
      delete m_app;
    }

  /* Now we are friendly enough to catch some Exceptions here and do some
   * cryptic output, even so most users won't find this more informative
   * than a simple "Aborted." . Hehe... */

  catch (Exception e)
    {
      cout << "Unhanded GSMP Exception:" << endl
	   << e << endl
	   << "Exiting." << endl;
      return -1;
    }

  catch (GSMX_utils::BaseException e)
    {
      cout << "Unhanded GSMP-utils Exception:" << endl
	   << e << endl
	   << "Exiting." << endl;
      return -1;
    }

  catch (GSML::BasicExcept e)
    {
      cout << "Unhanded GSML Exception:" << endl;
      cout << e.info << endl;
    }

  catch (...)
    {
      cout << "Unhanded Exception of unknown type" << endl
	   << "Exiting." << endl;
      return -1;
    }
  cout << "pre-last line in main" << endl;
  return 0;
}
