#include "PluginInterface.hh"
#include "Activator.hh"
#include "menutest.hh"

START_PLUGIN_INTERFACE;
PLUGIN_ITEM("Foo","Boo","Valentin","07-16-2001","ignored", NULL);
PLUGIN_ITEM("Foo","BooSel","Valentin","07-20-2001","ignored", NULL);
PLUGIN_ITEM("Foo","BooSiff","Valentin","07-21-2001","ignored", NULL);
END_PLUGIN_INTERFACE;

class FooBoo : public GSMP::Menu::Activator
{
private:

  virtual void Execute ()
  {
    if (m_view)
      m_view -> CheckThisFunc ();
    else if (m_project)
      m_project -> CheckThisFunc ();
    else
      m_app -> CheckThisFunc ();
  };

public:
  FooBoo (GSMP::App* i_app, GSMP::Project* i_project, GSMP::View* i_view) 
    : Activator (i_app, i_project, i_view)
  {
    cout << "FooBoo Constructed" << endl;
    m_app = i_app;
    m_project = i_project;
    m_view = i_view;
  }

  GSMP::App* m_app;
  GSMP::Project* m_project;
  GSMP::View* m_view;
};


class FooBooSiff : public GSMP::Menu::StatusActivator
{
private:

  virtual bool Execute (bool status)
  {
    if (m_view)
      cout << "View Check" << endl;
    else if (m_project)
      cout << "Project Check" << endl;
    else
      cout << "AppCheck" << endl;
    return status;
  };

public:
  FooBooSiff (GSMP::App* i_app, GSMP::Project* i_project, GSMP::View* i_view) 
    : StatusActivator (i_app, i_project, i_view)
  {
    cout << "FooBooSiff Constructed" << endl;
    m_app = i_app;
    m_project = i_project;
    m_view = i_view;
  }

  GSMP::App* m_app;
  GSMP::Project* m_project;
  GSMP::View* m_view;
};

class FooBooSel : public GSMP::Menu::PredicateActivator
{
private:

  virtual bool Execute ()
  {
    if (m_view)
      cout << "View Selection" << endl;
    else if (m_project)
      cout << "Project Selection" << endl;
    else
      cout << "AppSelection" << endl;
    return true;
  };

public:
  FooBooSel (GSMP::App* i_app, GSMP::Project* i_project, GSMP::View* i_view) 
    : PredicateActivator (i_app, i_project, i_view)
  {
    cout << "FooBooSel Constructed" << endl;
    m_app = i_app;
    m_project = i_project;
    m_view = i_view;
  }

  GSMP::App* m_app;
  GSMP::Project* m_project;
  GSMP::View* m_view;
};



PLUGIN_FACTORY(Foo,Boo,GSMP::Menu::Activator,FooBoo,(GSMP::App* i_app, GSMP::Project* i_project, GSMP::View* i_view),(i_app, i_project, i_view));
PLUGIN_FACTORY(Foo,BooSel,GSMP::Menu::PredicateActivator,FooBooSel,(GSMP::App* i_app, GSMP::Project* i_project, GSMP::View* i_view),(i_app, i_project, i_view));
PLUGIN_FACTORY(Foo,BooSiff,GSMP::Menu::StatusActivator,FooBooSiff,(GSMP::App* i_app, GSMP::Project* i_project, GSMP::View* i_view),(i_app, i_project, i_view));

