#include <iostream>
#include "Factory.hh"
#include "bogoplot.hh"

using namespace GSMX_utils;

main () 
{
  try
    {
      cout << Plugin::RegisterFile ("../lib/PluginSample.so") -> size () << " plugins registered." << endl;
    }
  catch (Plugin::Exception e)
    {
      cout << e << endl;
      exit (-1);
    }

  cout << "Listing Plugins" << endl;
  Plugin::content* c = Plugin::Categorys ();

  for (Plugin::content::const_iterator i = c -> begin (); i != c -> end (); ++i)
    {
      cout << (*i) << endl;
      Plugin::content* cc = Plugin::Items ((*i));
      for (Plugin::content::const_iterator ii = cc -> begin (); ii != cc -> end (); ++ii)
	{
	  cout << "\t" << (*ii) << endl;
	  const Plugin::Info info = Plugin::PlugInfo ((*i), (*ii));
	  cout << "\t\t Author   : " << info.author << endl;
	  cout << "\t\t Date     : " << info.date << endl;
	  cout << "\t\t Location : " << info.location << endl;
	}
      delete cc;
    }
  delete c;

  bogoplot* bp;

  try
    {
      bp = Plugin::Build <bogoplot, int> (string ("WavePlot"), string ("MinMax"), 23);
    }
  catch (Plugin::Exception e)
    {
      cout << e << endl;
    }
  delete bp;


  try
    {
      bp = Plugin::Build <bogoplot, int> (string ("WavePlot"), string ("Cubic"), 23);
    }
  catch (Plugin::Exception e)
    {
      cout << e << endl;
    }
  delete bp;

  try
    {
      bp = Plugin::Build <bogoplot, int> (string ("Foo"), string ("Foo"), 23);
    }
  catch (Plugin::Exception e)
    {
      cout << e << endl;
    }
  
}
