/* Some Macros for creation GSMX Plugins   (C) by V. Ziegler 2001
 
 ***************************************************************************
 *                                                                         *
 *   This code is free software; you can redistribute it and / or modify   *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PLUGIN_MACROS_HH
#define PLUGIN_MACROS_HH




#define START_PLUGIN_INTERFACE             \
namespace GSMX_utils                        \
{                                            \
  namespace Plugin                            \
  {                                            \
    namespace Generic                           \
    {                                            \
      std::deque <Interface* > content;           \
    };                                             \
  };                                                \
};                                                   \
                                                      \
extern "C" std::deque <GSMX_utils::Plugin::Interface*>&\
GSML_plugin_get_interface ()                            \
{                                                        \
  GSMX_utils::Plugin::Interface* i;







#define PLUGIN_ITEM(CATEGORY,NAME,AUTHOR,DATE,LOCATION, USER_DATA) \
  i = new GSMX_utils::Plugin::Interface ();                         \
  i -> info . category = CATEGORY ;                                  \
  i -> info . name = NAME ;                                           \
  i -> constructor = CATEGORY "_" NAME "_create";                      \
  i -> info . author = AUTHOR;                                          \
  i -> info . date = DATE;                                               \
  i -> info . location = LOCATION;                                        \
  i -> info . user_attached_data = USER_DATA;                              \
  GSMX_utils::Plugin::Generic::content.push_back (i);





#define END_PLUGIN_INTERFACE                   \
  return  GSMX_utils::Plugin::Generic::content; \
}






#define PLUGIN_FACTORY(CATEGORY,NAME,BASE,DERIVED,ARGUMENTS,EXPRESSION) \
extern "C" BASE* CATEGORY##_##NAME##_create ARGUMENTS                    \
{return new DERIVED EXPRESSION;}

#endif  //  PLUGIN_MACROS_HH
