/* Factory.cc (Template)     (C) by V. Ziegler 2001
 
 ***************************************************************************
 *                                                                         *
 *   This code is free software; you can redistribute it and / or modify   *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PLUGIN_FACTORY_HH
#  error "Never include this File in your code directly"
#  error "This file is automatically included by Factory.hh"
#endif

namespace GSMX_utils
{
  namespace Plugin
  {
    extern void* __LocateGenerator (const string&, const string&);

    template <class BASE>
    BASE* Build (const string& category, const string& name)
    {
      BASE* (*generator) () = (BASE* (*) ()) 
	__LocateGenerator (category, name);
      BASE* instance = generator ();
      return instance;
    }

    template <class BASE, class P1>
    BASE* Build (const string& category, const string& name, P1 p1)
    {
      BASE* (*generator) (P1) = (BASE* (*) (P1)) 
	__LocateGenerator (category, name);
      BASE* instance = generator (p1);
      return instance;
    }

    template <class BASE, class P1, class P2>
    BASE* Build (const string& category, const string& name, P1 p1, P2 p2)
    {
      BASE* (*generator) (P1, P2) = (BASE* (*) (P1, P2)) 
	__LocateGenerator (category, name);
      BASE* instance = generator (p1, p2);
      return instance;
    }

    template <class BASE, class P1, class P2, class P3>
    BASE* Build (const string& category, const string& name, P1 p1, P2 p2, P3 p3)
    {
      BASE* (*generator) (P1, P2, P3) = (BASE* (*) (P1, P2, P3)) 
	__LocateGenerator (category, name);
      BASE* instance = generator (p1, p2, p3);
      return instance;
    }

  }; // end namespace Plugin
}; // end namespace GSMX_utils
