/* Testing the Jobs CTor Ready behavior          (C) by R. Rebe 2001
 
 ***************************************************************************
 *                                                                         *
 *   This code is free software; you can redistribute it and / or modify   *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <iostream.h>
#include <unistd.h>
#include <string>
#include "Threads.hh"

using namespace std;

using namespace GSMX_utils::Threads;

class Joe : public Job
{
public:
  
  Joe (bool start_looping);
  virtual ~Joe ();
  
  bool looped;
  
protected:
  virtual void Loop ();
};

Joe::Joe (bool start_looping)
{
  looped = false;
  Ready (start_looping);
}

Joe::~Joe ()
{
}

void Joe::Loop ()
{
  cout << "Loop ..." << endl;
  
  looped = true;
  Wait ();
}

main ()
{
#define TESTS 15

  cout << "testing _should start_ ..." << endl;
  
  int tests, good_tests;
  
  tests = good_tests = 0;
  
  while (tests < TESTS)
    {
      Joe* t = new Joe (true);
      cout << "Created Thread" << endl;
      int waited = 0;
      while (! t -> looped && waited < 10) {
	cout << ".";
	usleep (100000);
	++ waited;
      }
      ++ tests;
      if (t -> looped)
	++ good_tests;
      delete t;
    }
  cout << "--> " << good_tests << " / " << tests << " good / tests" << endl;
  
  cout << "testing _should NOT start_ ..." << endl;
  
  tests = good_tests = 0;
  
  while (tests < TESTS)
    {
      Joe* t = new Joe (false);
      cout << "Created Thread" << endl;
      int waited = 0;
      while (! t -> looped && waited < 10) {
	cout << ".";
	usleep (100000);
	++ waited;
      }
      ++ tests;
      if (! t -> looped)
	++ good_tests;
      delete t;
    }
  cout << "--> " << good_tests << " / " << tests << " good / tests" << endl;
  
  cout << "exitting ..." << endl;
}
