/* Testing GCC exception handling in Threads     (C) by R. Rebe 2001
 
 ***************************************************************************
 *                                                                         *
 *   This code is free software; you can redistribute it and / or modify   *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <iostream.h>
#include <unistd.h>
#include <string>
#include "Threads.hh"

using namespace std;

using namespace GSMX_utils::Threads;

class Joe : public Job
{
public:
  
  Joe ();
  virtual ~Joe ();
  
  void Start ();
  
  int exceptions;
  
protected:
  virtual void Loop ();
};

Joe::Joe ()
{
  exceptions = 0;
  Ready (true);
}

Joe::~Joe ()
{
}

void Joe::Start ()
{
  Continue ();
}

void Joe::Loop ()
{
  cout << "Running..." << endl;
  
  try {
    // throw exception
    string s = "the exception";
    throw s;
  }
  catch (string& e)
    {
      cout << "OK - caught exception ..." << endl;
      ++ exceptions;
    }
  sleep (1);
}

main ()
{
  Joe* t = new Joe;
  cout << "Created Thread" << endl;
  
  t -> Start ();
  
  while (t -> exceptions < 10) {
    cout << "child thread caught " << t -> exceptions << " Exceptions ..." << endl;
    sleep (1);
  }
  delete t;
  cout << "exitting ..." << endl;
}
