/* Testing Function/Command Templates       (C) by V. Ziegler 2001
 
 ***************************************************************************
 *                                                                         *
 *   This code is free software; you can redistribute it and / or modify   *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <iostream.h>
#include <unistd.h>
#include <string>
#include "Threads.hh"

using namespace GSMX_utils::Threads;

class User : public Job
{
public:

//Function0 <void> f0;
  Function0 <int> f1;

  Function1 <void, int> f2;
  Function1 <int, int> f3;

  Function2 <void, int, int> f4;
  Function2 <int, int, int> f5;

  Function3 <void, int, int, int> f6;
  Function3 <int, int, int, int> f7;

  Command0 c0;
  Command1 <int> c1;
  Command2 <string, string> c2;
  Command3 <string, string, string> c3;

  void SyncW ()
  {
    SyncWait ();
  }

  void SyncC ()
  {
    Continue ();
  }

  User ();

protected:
  virtual void Loop ();
 
  void a ();
  int b ();

  void c (int);
  int d (int);
  
  void e (int, int);
  int f (int, int);

  void g (int, int, int);
  int h (int, int, int);

  void NonFunc ();
  void SleepSec (int); 
  void TwoFunc (string, string);
  void ThreeFunc (string, string, string);
};



void User::Loop ()
{
  sleep (1);
  cout << "Running..." << endl;
  if (IsRequest ())
    cout << "Da will wer was von mir :-)" << endl;
}


User::User ()
{
//f0.Connect (this, &User::a)
  f1.Connect (this, &User::b);
  f2.Connect (this, &User::c);
  f3.Connect (this, &User::d);
  f4.Connect (this, &User::e);
  f5.Connect (this, &User::f);
  f6.Connect (this, &User::g);
  f7.Connect (this, &User::h);

  c0.Connect (this, &User::NonFunc);
  c1.Connect (this, &User::SleepSec);
  c2.Connect (this, &User::TwoFunc);
  c3.Connect (this, &User::ThreeFunc);
  Ready (false);
}


void User::a ()
{
  cout << "a" << endl;
  Wait ();
}


int User::b ()
{
  cout << "b" << endl;
  Continue ();
  return 0;
}


void User::c (int i)
{
  cout << "c " << i << endl;
  Wait ();
}


int User::d (int i)
{
  cout << "d " << i << endl;
  Continue ();
  return i;
}


void User::e (int i, int j)
{
  cout << "e " << i << " " << j << endl;
  Wait ();
}


int User::f (int i, int j)
{
  cout << "f " << i << " " << j <<endl;
  return i + j;
}


void User::g (int i, int j, int k)
{
  cout << "g " << i <<  " " << j << " " << k << endl;
  Wait ();
}


int User::h (int i, int j , int k)
{
  cout << "h " << i <<  " " << j << " " << k << endl;
  return i + j + k;
}

void User::NonFunc ()
{
  cout << "Don't know whats up...." << endl;
}

void User::SleepSec (int seconds)
{
  sleep (seconds);
  Continue ();
}

void User::TwoFunc (string head, string tail)
{
  cout << head << " " << tail << endl;
}

void User::ThreeFunc (string head, string mid, string tail)
{
  cout << head << " " << mid << " " << tail << endl;
}


main ()
{
  User* Joe = new User;
  cout << "Created Joe.." << endl;
  sleep (3);

  cout << Joe -> f1 () << endl;
  sleep (2);

  Joe -> f2 (1);
  sleep (2);

  cout << Joe -> f3 (2) << endl;
  sleep (2);

  Joe -> f4 (3, 4);
  sleep (2);

  cout << Joe -> f5 (5, 6) << endl;
  sleep (2);

  Joe -> f6 (3, 4, 7);
  sleep (2);

  cout << Joe -> f7 (5, 6, 7) << endl;
  sleep (2);

  cout << "Commanding Joe to sleep 2 seconds" << endl;
  Joe -> c1 (2);
  cout << "done." << endl;

  Joe -> c0 ();

  cout << "Commanding Joe to sleep 3 seconds" << endl;
  Joe -> c1 (3);
  cout << "done." << endl;

  Joe -> c2 (string ("Hello"), string ("World"));
  Joe -> c3 (string ("Hello"), string ("World"), string ("!"));
  sleep (10);
  cout << "SyncronizeWait ()" << endl;
  Joe -> SyncW ();
  sleep (4);
  Joe -> SyncC ();
  sleep (2);
}
