/* Testing Property Templates       (C) by V. Ziegler 2001
 
 ***************************************************************************
 *                                                                         *
 *   This code is free software; you can redistribute it and / or modify   *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <iostream.h>
#include <unistd.h>
#include "Threads.hh"

using namespace GSMX_utils::Threads;

class Time : public SigC::Object
{
public:
  int hours;
  int minutes;
  int seconds;

  Time () {hours = 0; minutes = 0; seconds = 0;}
  Time (Time *t) {hours = t -> hours; minutes = t -> minutes; seconds = t -> seconds;}
};

class PseudoClock : public Job
{
public:
  PseudoClock ();
  Property <Time> oClock;
protected:
  virtual void Loop ();
};

void PseudoClock :: Loop ()
{
  sleep (1);

  oClock -> seconds ++;
  if (oClock -> seconds == 60)
    {
      oClock -> seconds = 0;
      oClock -> minutes ++;
	if (oClock -> minutes == 60)
	  {
	    oClock -> minutes = 0;
	    oClock -> hours ++;
	  }
    
    }

  oClock.Flush ();
}

PseudoClock :: PseudoClock ()
{
  Ready (true);
}

main ()
{
  PseudoClock* Clock = new PseudoClock;
  while (true)
    {
      SigC::Handle <Time, Scopes::Extend> current = Clock -> oClock ();
      
      cout << "\r";      
      cout.width (2); cout.fill ('0'); cout << current -> hours;
      cout << " : ";
      cout.width (2); cout.fill ('0'); cout << current -> minutes;
      cout << " : ";
      cout.width (2); cout.fill ('0'); cout << current -> seconds;
      cout.flush ();

      usleep (100000);
    }
}
