/* Access.hh      (C) by V. Ziegler 2001
 
 ***************************************************************************
 *                                                                         *
 *   This code is free software; you can redistribute it and / or modify   *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef THREAD_ACCESS_HH
#define THREAD_ACCESS_HH

#include <sigc++/object.h>
#include <sigc++/scope.h>
#include <sigc++/handle.h>
#include <sigc++/generator.h>
#include <sigc++/thread.h>

namespace GSMX_utils
{
  namespace Threads
  {
    using namespace std;
    using namespace SigC;
    using namespace SigC::Threads;

    template <class T>
    class Property
    {
    public:
      Handle <T, Scopes::Extend> operator () ();

      Property ();
      ~Property ();
  
      // following two are to be called by slave thread:
      T* operator -> () {return internal;}
      void Flush ();

    private:
      Handle <T, Scopes::Extend> external;
      T* internal;
      T* exchange;
      Mutex exchange__; // locks exchange Handle
    };

  }; // end namespace Threads
}; // end namespace GSMX_utils

#include "Templates/Access.cc"

#endif // THREAD_ACCESS_HH
