/* Commands.hh      (C) by V. Ziegler 2001
 
 ***************************************************************************
 *                                                                         *
 *   This code is free software; you can redistribute it and / or modify   *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef THREADS_COMMANDS_HH
#define THREADS_COMMANDS_HH

namespace GSMX_utils
{
  namespace Threads
  {
    namespace Private
    {

      class Command
      {
      public:
	virtual void Execute () {};
      };

      class CMDWait : public Command
      {
      public:
	CMDWait (Job* i_job) {m_job = i_job;}
	virtual void Execute () {m_job -> Wait ();}
      private:
	Job* m_job;
      };

      class CrossExec : public Command
      {
      public:
	CrossExec ();
	void Wait () {start.lock ();};
	virtual void Execute ();
	void Release () {finished.unlock ();};

      protected:
	Mutex start;
	Mutex finished;
      };

    }; // end namespace Private
  }; // end namespace Threads
}; // end namespace GSMX_utils

#endif // THREADS_COMMANDS_HH
