/* Exceptions.hh  (C) by V. Ziegler 2001
 
 ***************************************************************************
 *                                                                         *
 *   This code is free software; you can redistribute it and / or modify   *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef THREAD_EXCEPTIONS_HH
#define THREAD_EXCEPTIONS_HH

#include <string>
#include <iostream.h>

namespace GSMX_utils
{

#ifndef GSMX_BASE_EXCEPTION
#define GSMX_BASE_EXCEPTION

  /* this is the base for all Exceptions in GSMX Utils, GSML and GSMP */

  class BaseException
  {
  public:
    string info;

    BaseException () {};
    BaseException (const string& init_info) : info (init_info) {}; 
  };

  /* easy debuging output for "panic exception handlers" */

  ostream& operator << (ostream& s, const BaseException& e)
  {
    return s << e.info;
  }

#endif // GSMX_BASE_EXCEPTION

  namespace Threads
  {
    /* GSMx Thread exception */

    class Exception : public BaseException 
    {
    public:
      Exception (const string& errmsg) : BaseException (string ("Thread-system : ") + errmsg) {};
    };

  }; // end namespace Threads
}; // end namespase GSMX_utils

#endif // THREAD_EXCEPTIONS_HH
