/* Access.cc      (C) by V. Ziegler 2001
 
 ***************************************************************************
 *                                                                         *
 *   This code is free software; you can redistribute it and / or modify   *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef THREAD_ACCESS_HH
#  error "Never include this File in your code directly"
#  error "This file is automatically included by Access.hh"
#endif

namespace GSMX_utils
{
  namespace Threads
  {
    using namespace SigC;
    using namespace SigC::Threads;

    template <class T>
    Handle <T, Scopes::Extend>  Property <T> :: operator () () 
    {
      {
	MLock lazy (exchange__);
	if (exchange)
	  {
	    external = manage (exchange);
	    exchange = 0;
	  }
      }	  

      return external;
    }

    template <class T>
    Property <T> :: Property () 
    {
      internal = new T; Flush ();
    }

    template <class T>
    Property <T> :: ~Property () 
    {
      delete internal;
    }

    template <class T>
    void Property <T> :: Flush ()
    {
      MLock lazy (exchange__);
      if (exchange)
	delete exchange;
      exchange = internal;
      internal = new T (exchange);
    }

  }; // end namespace Threads
}; // end namespace GSMX_utils
